/* eslint-disable no-restricted-globals */

// This service worker can be customized!
// See https://developers.google.com/web/tools/workbox/modules
// for the list of available Workbox modules, or add any other
// code you'd like.
// You can also remove this file if you'd prefer not to use a
// service worker, and the Workbox build step will be skipped.

import { clientsClaim } from "workbox-core";
import { ExpirationPlugin } from "workbox-expiration";
import { precacheAndRoute, createHandlerBoundToURL } from "workbox-precaching";
import { registerRoute } from "workbox-routing";
import { StaleWhileRevalidate } from "workbox-strategies";

import Dexie from "dexie";
clientsClaim();

// Precache all of the assets generated by your build process.
// Their URLs are injected into the manifest variable below.
// This variable must be present somewhere in your service worker file,
// even if you decide not to use precaching. See https://cra.link/PWA
precacheAndRoute(self.__WB_MANIFEST);

// Set up App Shell-style routing, so that all navigation requests
// are fulfilled with your index.html shell. Learn more at
// https://developers.google.com/web/fundamentals/architecture/app-shell
const fileExtensionRegexp = new RegExp("/[^/?]+\\.[^/]+$");
registerRoute(
  // Return false to exempt requests from being fulfilled by index.html.
  ({ request, url }) => {
    // If this isn't a navigation, skip.
    if (request.mode !== "navigate") {
      return false;
    } // If this is a URL that starts with /_, skip.

    if (url.pathname.startsWith("/_")) {
      return false;
    } // If this looks like a URL for a resource, because it contains // a file extension, skip.

    if (url.pathname.match(fileExtensionRegexp)) {
      return false;
    } // Return true to signal that we want to use the handler.

    return true;
  },
  createHandlerBoundToURL(process.env.PUBLIC_URL + "/index.html")
);

// An example runtime caching route for requests that aren't handled by the
// precache, in this case same-origin .png requests like those from in public/
registerRoute(
  // Add in any other file extensions or routing criteria as needed.
  ({ url }) =>
    url.origin === self.location.origin && url.pathname.endsWith(".png"), // Customize this strategy as needed, e.g., by changing to CacheFirst.
  new StaleWhileRevalidate({
    cacheName: "images",
    plugins: [
      // Ensure that once this runtime cache reaches a maximum size the
      // least-recently used images are removed.
      new ExpirationPlugin({ maxEntries: 50 }),
    ],
  })
);

// This allows the web app to trigger skipWaiting via
// registration.waiting.postMessage({type: 'SKIP_WAITING'})
self.addEventListener("message", (event) => {
  if (event.data && event.data.type === "SKIP_WAITING") {
    self.skipWaiting();
  }
});

// Any other custom service worker logic can go here.
// var CACHE_NAME = "my-pwa-cache-v1";
// var urlsToCache = ["/", "/styles/styles.css", "/script/webpack-bundle.js"];
// self.addEventListener("install", function (event) {
//   event.waitUntil(
//     caches.open(CACHE_NAME).then(function (cache) {
//       // Open a cache and cache our files
//       return cache.addAll(urlsToCache);
//     })
//   );
// });

// Listen to fetch requests
self.addEventListener("fetch", function (event) {
  // We will cache all POST requests, but in the real world, you will probably filter for
  // specific URLs like if(... || event.request.url.href.match(...))

  if (
    event.request.method !== "POST" ||
    !event.request.url.startsWith(process.env.PUBLIC_URL + "/jsonrpc.js?")
  ) {
    return;
  }

  // Init the cache. We use Dexie here to simplify the code. You can use any other
  // way to access IndexedDB of course.
  var db = new Dexie("post_cache");
  db.version(1).stores({
    post_cache: "key,response,timestamp",
  });
  db.open();

  var id = event.request.url.replace(
    process.env.PUBLIC_URL + "/jsonrpc.js?",
    ""
  );

  event.respondWith(
    db.post_cache.get(id).then((cachedData) => {
      if (typeof cachedData !== "undefined") {
        console.log(cachedData.response);
        var blob = new Blob([cachedData.response], {
          type: "application/json",
        });

        var init = { status: 200, statusText: "OK" };
        var responseFromCache = new Response(blob, init);

        console.log("returning cached response");
        console.log(responseFromCache);
        return responseFromCache;
      }

      // First try to fetch the request from the server
      console.log("fetch it");
      console.log(event.request);
      let promiseResponse = fetch(event.request.clone())
        .then((response) => {
          // If it works, put the response into IndexedDB
          console.log("cache it ");
          cachePut(id, response.clone(), db.post_cache);
          console.log("returning fetch response");
          console.log(response);
          return response;
        })
        .catch(function (error) {
          console.log("error");
          console.log(error);
          // If it does not work, return the cached response. If the cache does not
          // contain a response for our request, it will give us a 503-response
          var myBlob = new Blob();
          var init = { status: 500, statusText: "Oopsie" };
          var errResponse = new Response(myBlob, init);
          return errResponse;
        });
      return promiseResponse;
    })
  );
});

/**
 * Saves the response for the given request eventually overriding the previous version
 *
 * @param data
 * @returns Promise
 */
function cachePut(id, response, post_cache) {
  response
    .text()
    .then((responseBody) => {
      var entry = {
        key: id,
        response: responseBody,
        timestamp: Date.now(),
      };
      console.log(entry);
      return entry;
    })
    .then((entry) => {
      post_cache
        .put(entry)
        .then((key) => {
          console.log("Put it worked");
          console.log(key);
        })
        .catch((error) => {
          console.log("Put it failed");

          console.log(error);
        });
    });
}
